<?php
/**
 * Created by PhpStorm.
 * User: David Gaylord
 * Description:
 * Date: 10/20/2016
 * Time: 9:39 AM
 */
defined( 'ABSPATH' ) or die( "Cannot access pages directly." );

class CMS_Utils {
	/****TO DO***/
	/* 
	   1. Parameratize url so it can point to dev or prod machine
	   2. Give user the output of saving the json file or just reading json output from response (currently not operational)
	*/
	public static function cms_site_to_json($site_id) {

		//initiate a CURL request to admin/wp/exportSiteToJSON.do with site paramater
		//check to make sure json file exists in /cms/wp_migrate (or wherever)
		//return url to json file or failure
		try {
			echo "<br />Exporting site from CMS, this may take a moment...";
			$ch = curl_init( 'http://www-dev.whoi.edu/json/wp/cmsSitesToJson.do?json=true&siteId=' . $site_id );
			curl_setopt_array( $ch, array(

				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_HTTPHEADER     => array(
					'Content-Type: application/json'
				)

			) );

			// Send the request
			$response = curl_exec( $ch );
			// Check for errors
			if ( $response === false ) {
				echo "<br />Error";
				die( curl_error( $ch ) );
			}
		} catch( Exception $e ) {
			echo 'Exception exporting site from CMS: ', $e->getMessage(), "\n";
		}

	}

	public static function cms_page_to_json($page_id) {

		//initiate a CURL request to admin/wp/exportSiteToJSON.do with site paramater
		//check to make sure json file exists in /cms/wp_migrate (or wherever)
		//return url to json file or failure
		try {
			echo "<br />Exporting site from CMS, this may take a moment...";
			//$ch = curl_init( 'http://acadia.whoi.edu/json/wp/cmsSitesToJson.do?json=true&pageId=' . $page_id );
			$ch = curl_init( 'http://www-dev.whoi.edu/json/wp/cmsSitesToJson.do?json=true&pageId=' . $page_id );
			curl_setopt_array( $ch, array(

				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_HTTPHEADER     => array(
					'Content-Type: application/json'
				)

			) );

			// Send the request
			$response = curl_exec( $ch );
			// Check for errors
			if ( $response === false ) {
				echo "<br />Error";
				die( curl_error( $ch ) );
			}
		} catch( Exception $e ) {
			echo 'Exception exporting page from CMS: ', $e->getMessage(), "\n";
		}

	}

	public static function cms_litesite_to_json($litesite_id) {

		//initiate a CURL request to admin/wp/exportSiteToJSON.do with site paramater
		//check to make sure json file exists in /cms/wp_migrate (or wherever)
		//return url to json file or failure
		try {
			echo "<br />Exporting site from CMS, this may take a moment...";
			//$ch = curl_init( 'http://acadia.whoi.edu/json/wp/cmsSitesToJson.do?json=true&pageId=' . $page_id );
			$ch = curl_init( 'http://www-dev.whoi.edu/json/wp/liteSitesToJson.do?json=true&liteSiteId=' . $litesite_id );
			curl_setopt_array( $ch, array(

				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_HTTPHEADER     => array(
					'Content-Type: application/json'
				)

			) );

			// Send the request
			$response = curl_exec( $ch );
			// Check for errors
			if ( $response === false ) {
				echo "<br />Error";
				die( curl_error( $ch ) );
			}
		} catch( Exception $e ) {
			echo 'Exception exporting page from CMS: ', $e->getMessage(), "\n";
		}

	}

	function delete_json_file() {
		//at conclusion of a successful import into wordpress delete the json file we used
		//return success or failure
	}

	/*Create a basic landing page (index page in CMS terms), if we don't auto generate this page
	we end up with a blank page.*/
	public static function create_landing_page($landing_page) {
		$page_children = get_pages( array( 'child_of' => $landing_page, 'sort_column' => 'menu_order', 'sort_order' => 'asc', 'depth' => '1' ) );
		$page_content = "";
		if (isset($page_children)) {
			foreach ($page_children as $child) {
				$page_content = $page_content."<p>".$child -> post_thumbnail ."<a href = \"".get_permalink($child->ID)."\">".$child -> post_title."</a></p>";

			}
		}
		return $page_content;
	}


}